unit TestComm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Tcomm, Buttons, StdCtrls, ExtCtrls, Settings;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    SpeedButton1: TSpeedButton;
    Memo1: TMemo;
    SpeedButton3: TSpeedButton;
    SpeedButton6: TSpeedButton;
    CommPort1: TCommPort;
    Memo2: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    SpeedButton2: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Memo1KeyPress(Sender: TObject; var Key: Char);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  quitterm : integer;
  ComName,
  Speed     : String;
  _Parity   : TParity;
  Stop_Bits : TStop;
  Byte_Size : TByte;
  IsParity  : Boolean;

implementation

{$R *.DFM}

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
s1,s2,s3,s4,S5: String;
I1,I2,I3,I4,I5:Integer;
W1 : Word;
                           
begin
  W1 := CommPort1.DCB.BaudRate;
  str(W1,S1);

  I2:=CommPort1.DCB.ByteSize;
  Str(I2,S2);

  I3 := CommPort1.DCB.Parity;
  Str(I3,S3);

  I4 := CommPort1.WComId;
  Str(I4,s4);

  I5 := CommPort1.DCB.StopBits;
  Str(I5,s5);

  Panel2.Caption:='CommID: '+s4+' Baud: '+S1+' Size '+S2 + ' Parity: ' + S3 +
  ' StopBits ' + S5 ;

end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
  begin
    close;
  end;


procedure TForm1.Memo1KeyPress(Sender: TObject; var Key: Char);
var
 lstr : string;
begin
{  lstr:='';
   lstr:=lstr+key;
   commport1.writecommstring(lstr);
 }
 {This example is actually works. To see how you can decomment  it
 and type in the Memo1 command string e.g. ATDT  and press Enter. D.V.B.}
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
var
i    : integer;
begin
   commport1.ReadAnyString;
   for i := 0 to  CommPort1.RxBufferSize - 1 do
  Memo2.Text:=Memo2.Text + CommPort1.ReceiveBuf[i];
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
var
  I,
  x:longint;
begin
  x:=0;
  commport1.writecommstring(Memo1.text);
  commport1.ReadAnyString;
  for i := 0 to  CommPort1.RxBufferSize - 1 do
  Memo2.Text:=Memo2.Text + CommPort1.ReceiveBuf[i];
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  commport1.open;
  Panel2.Caption := '';
  if commport1.WCommID < 0 then
    begin
      showmessage ('Failed to Open Port.');
    end
  else
    showMessage('Port Is Opened');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Commport1.ClosePort;
 Panel2.Caption := '';
if commport1.WCommID < 0 then
  begin
    showMessage('Port Is Closed');
  end
else
  showmessage ('Failed to close port.');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
FormSettings.showmodal;
end;

end.
